import logging
import math
import os
import sys
import time

from fischertechnik.controller.Motor import Motor
from lib.controller import *
from numbers import Number


_ABSLIMIT = None
num = None
msg = None
rv = None
av = None
abspos = None
tsdiff = None
_b_exit = None
ABSLIMIT = None
_ref_valid = None
SPEED = None
ts0 = None
TIMEOUT_S = None
temp = None
SPEED_REF = None
def _update_abspos(num, rv):
    global _ABSLIMIT, msg, av, abspos, tsdiff, _b_exit, ABSLIMIT, _ref_valid, SPEED, ts0, TIMEOUT_S, temp, SPEED_REF
    if num < 1 or num > 4:
        logging.error('num out of bounds: %d', num)
        return
    if abspos[int(num - 1)] == None:
        logging.error('abspos[num]=None')
        return
    logging.debug('num=%d, rv=%d abspos[num]=%d' , num, rv, abspos[num-1])
    temp = None
    if num == 1:
        temp = (temp if isinstance(temp, Number) else 0) + (TXT_M_C1_motor_step_counter.get_count())
    elif num == 2:
        temp = (temp if isinstance(temp, Number) else 0) + (TXT_M_C2_motor_step_counter.get_count())
    elif num == 3:
        temp = (temp if isinstance(temp, Number) else 0) + (TXT_M_C3_motor_step_counter.get_count())
    elif num == 4:
        temp = (temp if isinstance(temp, Number) else 0) + (TXT_M_C4_motor_step_counter.get_count())
    if rv > 0:
        abspos[int(num - 1)] = abspos[int(num - 1)] + temp
        logging.debug('set abspos[%d]+=%d', num, abspos[num-1])
    elif rv < 0:
        abspos[int(num - 1)] = abspos[int(num - 1)] - temp
        logging.debug('set abspos[%d]-=%d', num, abspos[num-1])



def init_Axes1Ref(_ABSLIMIT):
    global num, msg, rv, av, abspos, tsdiff, _b_exit, ABSLIMIT, _ref_valid, SPEED, ts0, TIMEOUT_S, temp, SPEED_REF
    logging.debug('init')
    abspos = [None] * 4
    ABSLIMIT = _ABSLIMIT
    SPEED = 512
    SPEED_REF = 200
    ts0 = [0] * 4
    tsdiff = [0] * 4
    TIMEOUT_S = 20
    _b_exit = False
    _ref_valid = [False] * 4


def get_abspos():
    global _ABSLIMIT, num, msg, rv, av, abspos, tsdiff, _b_exit, ABSLIMIT, _ref_valid, SPEED, ts0, TIMEOUT_S, temp, SPEED_REF
    return abspos


def _check_timeout_exit(num):
    global _ABSLIMIT, msg, rv, av, abspos, tsdiff, _b_exit, ABSLIMIT, _ref_valid, SPEED, ts0, TIMEOUT_S, temp, SPEED_REF
    tsdiff[int(num - 1)] = time.time() - ts0[int(num - 1)]
    if tsdiff[int(num - 1)] > TIMEOUT_S:
        logging.warning('timeout[%d] %.1f (%.1f), exit program', num, tsdiff[num-1], TIMEOUT_S)
        _exit_Axes1Ref('timeout {}s (max: {}s)'.format(round(tsdiff[int(num - 1)], 1), TIMEOUT_S))
    time.sleep(0.001)


def _exit_Axes1Ref(msg):
    global _ABSLIMIT, num, rv, av, abspos, tsdiff, _b_exit, ABSLIMIT, _ref_valid, SPEED, ts0, TIMEOUT_S, temp, SPEED_REF
    logging.error('exit')
    _b_exit = True
    _ref_valid = [False] * 4
    msg = 'error in Axes1Ref: {}'.format(msg)
    #thread.interrupt_main()
    #raise SystemExit(msg) #not for threads!
    #sys.exit(msg) #not for threads!

    logging.error(msg)
    os._exit(os.EX_OK)


def moveRef(num):
    global _ABSLIMIT, msg, rv, av, abspos, tsdiff, _b_exit, ABSLIMIT, _ref_valid, SPEED, ts0, TIMEOUT_S, temp, SPEED_REF
    if num < 1 or num > 4:
        logging.error('num out of bounds: %d', num)
        return
    logging.debug('num=%d', num)
    ts0[int(num - 1)] = time.time()
    if num == 1:
        TXT_M_M1_encodermotor.set_speed(int(SPEED), Motor.CCW)
        TXT_M_M1_encodermotor.start_sync()
        while not ((TXT_M_I1_mini_switch.is_closed()) or _b_exit):
            _check_timeout_exit(num)
        TXT_M_M1_encodermotor.stop_sync()
        TXT_M_M1_encodermotor.set_speed(int(SPEED_REF), Motor.CW)
        TXT_M_M1_encodermotor.start_sync()
        while not ((TXT_M_I1_mini_switch.is_open()) or _b_exit):
            _check_timeout_exit(num)
        TXT_M_M1_encodermotor.stop_sync()
    elif num == 2:
        TXT_M_M2_encodermotor.set_speed(int(SPEED), Motor.CCW)
        TXT_M_M2_encodermotor.start_sync()
        while not ((TXT_M_I2_mini_switch.is_closed()) or _b_exit):
            _check_timeout_exit(num)
        TXT_M_M2_encodermotor.stop_sync()
        TXT_M_M2_encodermotor.set_speed(int(SPEED_REF), Motor.CW)
        TXT_M_M2_encodermotor.start_sync()
        while not ((TXT_M_I2_mini_switch.is_open()) or _b_exit):
            _check_timeout_exit(num)
        TXT_M_M2_encodermotor.stop_sync()
    elif num == 3:
        TXT_M_M3_encodermotor.set_speed(int(SPEED), Motor.CCW)
        TXT_M_M3_encodermotor.start_sync()
        while not ((TXT_M_I3_mini_switch.is_closed()) or _b_exit):
            _check_timeout_exit(num)
        TXT_M_M3_encodermotor.stop_sync()
        TXT_M_M3_encodermotor.set_speed(int(SPEED_REF), Motor.CW)
        TXT_M_M3_encodermotor.start_sync()
        while not ((TXT_M_I3_mini_switch.is_open()) or _b_exit):
            _check_timeout_exit(num)
        TXT_M_M3_encodermotor.stop_sync()
    elif num == 4:
        TXT_M_M4_encodermotor.set_speed(int(SPEED), Motor.CCW)
        TXT_M_M4_encodermotor.start_sync()
        while not ((TXT_M_I4_mini_switch.is_closed()) or _b_exit):
            _check_timeout_exit(num)
        TXT_M_M4_encodermotor.stop_sync()
        TXT_M_M4_encodermotor.set_speed(int(SPEED_REF), Motor.CW)
        TXT_M_M4_encodermotor.start_sync()
        while not ((TXT_M_I3_mini_switch.is_open()) or _b_exit):
            _check_timeout_exit(num)
        TXT_M_M4_encodermotor.stop_sync()
    abspos[int(num - 1)] = 0
    _ref_valid[int(num - 1)] = True
    logging.debug('stop')


def moveRel(num, rv):
    global _ABSLIMIT, msg, av, abspos, tsdiff, _b_exit, ABSLIMIT, _ref_valid, SPEED, ts0, TIMEOUT_S, temp, SPEED_REF
    if num < 1 or num > 4:
        logging.error('num out of bounds: %d', num)
        return
    if not _ref_valid[int(num - 1)]:
        logging.error('ref not valid')
        return
    if abspos[int(num - 1)] == None:
        logging.error('abspos[num]=None')
        return
    logging.debug('num=%d, rv=%d, abspos[num]=%d, ABSLIMIT[num]=%d', num, rv, abspos[num-1], ABSLIMIT[num-1])
    ts0[int(num - 1)] = time.time()
    temp = abspos[int(num - 1)] + rv
    if rv > 0:
        if temp <= ABSLIMIT[int(num - 1)]:
            if num == 1:
                TXT_M_M1_encodermotor.set_speed(int(SPEED), Motor.CW)
                TXT_M_M1_encodermotor.set_distance(int(math.fabs(rv)))
            elif num == 2:
                TXT_M_M2_encodermotor.set_speed(int(SPEED), Motor.CW)
                TXT_M_M2_encodermotor.set_distance(int(math.fabs(rv)))
            elif num == 3:
                TXT_M_M3_encodermotor.set_speed(int(SPEED), Motor.CW)
                TXT_M_M3_encodermotor.set_distance(int(math.fabs(rv)))
            elif num == 4:
                TXT_M_M4_encodermotor.set_speed(int(SPEED), Motor.CW)
                TXT_M_M4_encodermotor.set_distance(int(math.fabs(rv)))
        else:
            _exit_Axes1Ref('num {} out of bounds {} > {}'.format(num, temp, ABSLIMIT[int(num - 1)]))
            return
    elif rv < 0:
        if temp > 0:
            if num == 1:
                TXT_M_M1_encodermotor.set_speed(int(SPEED), Motor.CCW)
                TXT_M_M1_encodermotor.set_distance(int(math.fabs(rv)))
            elif num == 2:
                TXT_M_M2_encodermotor.set_speed(int(SPEED), Motor.CCW)
                TXT_M_M2_encodermotor.set_distance(int(math.fabs(rv)))
            elif num == 3:
                TXT_M_M3_encodermotor.set_speed(int(SPEED), Motor.CCW)
                TXT_M_M3_encodermotor.set_distance(int(math.fabs(rv)))
            elif num == 4:
                TXT_M_M4_encodermotor.set_speed(int(SPEED), Motor.CCW)
                TXT_M_M4_encodermotor.set_distance(int(math.fabs(rv)))
        elif temp == 0:
            logging.debug('no action required')
        else:
            _exit_Axes1Ref('num {} out of bounds {} > {}'.format(num, temp, ABSLIMIT[int(num - 1)]))
            return
    if num == 1:
        while not ((not TXT_M_M1_encodermotor.is_running()) or _b_exit):
            _check_timeout_exit(num)
    elif num == 2:
        while not ((not TXT_M_M2_encodermotor.is_running()) or _b_exit):
            _check_timeout_exit(num)
    elif num == 3:
        while not ((not TXT_M_M3_encodermotor.is_running()) or _b_exit):
            _check_timeout_exit(num)
    elif num == 4:
        while not ((not TXT_M_M4_encodermotor.is_running()) or _b_exit):
            _check_timeout_exit(num)
    _update_abspos(num, rv)


def moveAbs(num, av):
    global _ABSLIMIT, msg, rv, abspos, tsdiff, _b_exit, ABSLIMIT, _ref_valid, SPEED, ts0, TIMEOUT_S, temp, SPEED_REF
    if num < 1 or num > 4:
        logging.error('num out of bounds: %d', num)
        return
    if not _ref_valid[int(num - 1)]:
        logging.error('ref not valid')
        return
    logging.debug('num=%d, av=%d, abspos[num]=%d, ABSLIMIT[num]=%d', num, av, abspos[num-1], ABSLIMIT[num-1])
    if abspos[int(num - 1)] == None:
        _exit_Axes1Ref('num {} no ref, abspos not valid {}'.format(num, abspos[int(num - 1)]))
        return
    else:
        moveRel(num, av - abspos[int(num - 1)])


